/************************************************************************
 *  -.    ifmail'.		*
 * Copyright (C) 1998-1999	Maxim Timofeyev, 2:5030/763 (v0.1-v0.5)	*
 * 				Ilya Yanok, 2:5030/763.11 (v0.6)	*
 ************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <syslog.h>
#include <fcntl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <unistd.h>
#include <locale.h>
#include <time.h>
#include <ctype.h>
#include <glob.h>
#include <errno.h>
#include "config.h"

static char FTNADDR[21];
static char REQFILE[255];
static char OUTFILE[255];
static char REPFILE[255];

static char FLAGS[6];
static char METHOD[7];
static char SPEED[7];
static int iSPEED;
static int PASSW;

static int NFILE = 0;		// -  
static unsigned int NSIZE = 0;	//   

// 0 - protected system, 1 - listed system, 2 - other system
static unsigned int MaxFile[3]	= {10, 3, 1};
static unsigned int Size[3]	= {10485760, 5245880, 1572864};

static unsigned int TSIZE = 0;	//   
static int fout;		//   OUTFILE
static int frep;		//   REPFILE
static int logfile;		//   LOGFILE

static char LOGINIT[80];	//  ,    log-

int main(int argc, char **argv)
{
	int n=argc;
	int arg=1;
	char ver[255];

	loginit();
	sprintf(ver, "External freq processor (v%d.%d) (C) Maxim Timofeyev, 2:5030/763", VER, SUBVER);
	mylog(ver);

	//   
	strcpy(FLAGS,"-e");
	strcpy(SPEED,"-s0");
	strcpy(METHOD,"-wazoo");
	PASSW=2;

	readconfig();

	if ( argc < 5 )
	{
		mylog ("Error: invalid arguments!");
		myexit ();	//  
		exit (1);
	}
	if ( argc > 5 )
	{
		while ( n > 5 )
		{
			if ( analysis(argv[arg++]) != 0 )
			{
				mylog ("Error: too many arguments!");
				myexit ();	//  
				exit (1);
			}
			n--;
		}
		speed();	//  
	}
	strcpy(FTNADDR, argv[arg++]);
	strcpy(REQFILE, argv[arg++]);
	strcpy(OUTFILE, argv[arg++]);
	strcpy(REPFILE, argv[arg++]);

	openfile();	//   OUTFILE & REPFILE
	if ( freqfile() != 0 )
	{
		mylog ("Error: cannot open reqfile!");
		myexit ();
		close (frep);
		close (fout);
		exit (1);
	}
	close (frep);
	close (fout);
	close (logfile);
	exit (0);
}

//  char SPEED  integer...
speed()
{
	int n = 0, m = 2;
	char buf[11];	//   - 999'999'999 / ;)
	while ( SPEED[m] != 0 )
		buf[n++] = SPEED[m++];
	buf[n] = 0;
	iSPEED = atoi (buf);
}

//  REP & OUT 
openfile()
{
	frep = open(REPFILE, O_WRONLY | O_APPEND | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR | S_IRGRP);	//  REP -
	fout = open(OUTFILE, O_WRONLY | O_APPEND | O_CREAT | O_TRUNC, S_IRUSR | S_IWUSR | S_IRGRP);	//  OUT -
}

//  LOG 
OpenLog()
{
	logfile = open(LOGFILE, O_WRONLY | O_APPEND | O_CREAT, S_IRUSR | S_IWUSR | S_IRGRP);	//  log -
}

//  
analysis(char *arg)
{
	if ( strncmp(arg, "-e", 2) == 0 )
	{
		strcpy(FLAGS, arg);
		return (0);
	}
	if ( strncmp(arg, "-s", 2) == 0)
	{
		strcpy(SPEED, arg);
		return (0);
	}
	if ( strncmp(arg, "-w", 2) == 0 || strncmp(arg, "-b", 2) == 0 )
	{
		strcpy(METHOD, arg);
		return (0);
	}
	if ( strncmp(arg, "-p", 2) == 0)
	{
		PASSW=0;	//  
		return (0);
	}
	if ( strncmp(arg, "-l", 2) == 0)
	{
		PASSW=1;	//  
		return (0);
	}
	return (1);
}

readconfig()
{
	int file;
	char buffer[255];
	if ((file = open(CONFIG, O_RDONLY, 0)) == -1)
	{
		mylog("Error open config file! Use default.");
		return (1);
	}
	while ( getline(file, buffer,sizeof(buffer)) != 0 )
	{
		if ( buffer[0] == 'A' )
			breakMaxFile(buffer, 0);
		if ( buffer[0] == 'B' )
			breakSize(buffer, 0);
		if ( buffer[0] == 'C' )
			breakMaxFile(buffer, 1);
		if ( buffer[0] == 'D' )
			breakSize(buffer, 1);
		if ( buffer[0] == 'E' )
			breakMaxFile(buffer, 2);
		if ( buffer[0] == 'F' )
			breakSize(buffer, 2);
	}
	close(file);
	return (0);
}

breakMaxFile(char *buf, int n)
{
	buf++;
	MaxFile[n] = strtoul(buf, 0, 0);
}

breakSize(char *buf, int n)
{
	buf++;
	Size[n] = strtoul(buf, 0, 0);
}

//   
int getline(int fdesc, char* buf,int max)
{
	int n=-1;
	do
		n++;
	while( read(fdesc, buf+n, 1) !=0 && buf[n] != '\xA' && n< max-1);
	buf[n] = 0;
	return ( strlen(buf) );	//   
}

// ""   
void getlow(char* buffer)
{
	int i = 0;
	while (buffer[i] != 0)
	{
		if (buffer[i] > 64 && buffer[i] < 91)
			buffer[i] = buffer[i] + 32;
		i++;
	}
}

void uncase(char* in) 
{	
	char out[512];
	int i=0,k=0,flag=0;
	for (;in[i] && k<511;i++,k++)
		if (flag)
		{
			if ( in[i]==']' && in[i-1]!='\\' )
				flag=0;
		}
		else
		{
			if (in[i]=='[' && ( i==0 || in[i-1]!='\\' ) )
				flag=1;
			if (isalpha(in[i]) )
			{
				out[k]='[';
				out[k+1]=in[i];
				out[k+2]=toupper(in[i]);
				out[k+3]=']';
				k+=3;
			}
			else
				out[k]=in[i];
		};
	out[k]=0;
	strcpy(in,out);
}

//     freq -
// : errorlevel
// 	0 - freq -  .
// 	1 - !  -.
freqfile()
{
	int i, file, flag;
	int maxfile = MaxFile[PASSW];
	unsigned int size;
	char name[512];
	char newname[512];
	char dir[512];
	char buf[512];
	char ftnsys[3][14] = {"the protected", "the listed", "an unlisted"};

	int file1;
	int sys;
	unsigned int sizetmp;

	glob_t globbuf;

	char fullname[1024];
	int wdir,k;
	size_t strl;
	char no_match;
	
	globbuf.gl_pathc=0;
	globbuf.gl_pathv=NULL;

	if ((file = open(REQFILE, O_RDONLY, 0)) == -1 )
		//  FREQ - !
		return (1);
	if ( !iSPEED )
		sprintf(buf, "Connected system - %s, speed - unknown", FTNADDR);
	else
		sprintf(buf, "Connected system - %s, speed - %d", FTNADDR, iSPEED);
	mylog(buf);	//      
	sprintf(buf, "Session with %s system...", ftnsys[PASSW]);
	mylog(buf);	//     ...
	sprintf(buf, "Limits for this system are: %d file(s), %d bytes", MaxFile[PASSW], Size[PASSW]);
	mylog(buf);	//     .
	while ( 1 )
	{
		if ( getline(file, name , sizeof (name) ) == 0 )
			{
				close (file);
				//   freq - 
				break;
			}
		i = strlen(name); i--;
		while ( name[i] == '\x7C' )
			name[i--] = 0;
		/*if ( maxfile <= 0 )
		{
			if  ( checkname(name) )
				security(name);
			else
				manyfile(name);
		}
		else
		{*/
		if ( checkname(name) )	//    
		{	
			security(name);
			continue;
		};
		//  -   .
		strcpy (newname, name);	//  
		getlow(name);	// ""  
		flag = foundalias(name, dir);
		if ( flag == 0 )
		//{
			glob(dir,GLOB_NOSORT|GLOB_APPEND|GLOB_MARK|GLOB_NOCHECK,NULL,&globbuf);
			/*descfile(name, dir, 1);
			maxfile--
		};
		if ( flag == 3 )
			security(name);
		}*/
#ifndef CASESENS
		uncase(name);
#else
		strcpy(name,newname);
#endif
		if ( /*maxfile > 0 &&*/ flag == 1 )
		{
			//     -  .
			/*flag = foundfile(name);
			if ( flag == 1 )
			{
				//     
				//  -  !
				if ( foundfile(newname) == 1 )
					repwithoutfile(newname);
			}
			if ( flag == 3 )
				security(name);
			if ( flag >= 2 )	// 2  3
				maxfile++;	//  . .*/
			if ((file1 = open(DIRS, O_RDONLY, 0)) == -1 )
			//    !
				repwithoutfile (name);
			no_match=1;
			do
			{
				if ( getline(file1, dir , sizeof (dir) ) == 0 )
				{	
					close (file1);
					//    !
					break;
				}
				if ( !whatsys(dir) )
				{
					sprintf(fullname,"%s/%s",dir,name);
					if ( glob(fullname,GLOB_NOSORT|GLOB_APPEND|GLOB_MARK,NULL,&globbuf) != GLOB_NOMATCH )
						no_match=0;
				};
			}
			while ( 1 );
			if ( no_match ) 
			{
#ifndef CASESENS
				sprintf(fullname,"%s/%s",dir,newname);
#endif
				glob(fullname,GLOB_NOSORT|GLOB_APPEND|GLOB_MARK|GLOB_NOCHECK,NULL,&globbuf);
			};
		}
				
	}
	for(k=0;k<globbuf.gl_pathc;k++)
	{
		strl=strlen(globbuf.gl_pathv[k]);
		for (i=2;globbuf.gl_pathv[k][strl-i]!='/';i++);
		globbuf.gl_pathv[k][strl-i]=0;
		i--;
		if (globbuf.gl_pathv[k][strl-1]=='/')
		{
			security(globbuf.gl_pathv[k]+strl-i);
			continue;
		};
		if(maxfile<=0)
		{
			manyfile(globbuf.gl_pathv[k]+strl-i);
			continue;
		};
		if(sizefile(globbuf.gl_pathv[k]+strl-i,globbuf.gl_pathv[k],0)!=0)
		{
			repwithoutfile(globbuf.gl_pathv[k]+strl-i);
			continue;
		};
		if((TSIZE+NSIZE)>Size[PASSW])
		{
			limitfile(globbuf.gl_pathv[k]+strl-i);
			continue;
		}
		else
		{
			descfile(globbuf.gl_pathv[k]+strl-i,globbuf.gl_pathv[k],0);
			NSIZE+=TSIZE;
			maxfile--;
		};
		globbuf.gl_pathv[k][strl-i-1]='/';
	};
	globfree(&globbuf);
	endrep();	//  ""
	return (0);
}

/*
 *   .
 * : name -  
 *      ,     ,
 *  errorlevel = 1,    - 0, 2 -  ,
 * 3 -   .
*/
/*foundfile(char* name)
{
	int file;
	int sys;
	unsigned int sizetmp;
	char dir[255];
	if ( checkname(name) )	//    
		return (3);
	if ((file = open(DIRS, O_RDONLY, 0)) == -1 )
		//    !
		return (1);
	do
	{
		if ( getline(file, dir) == 0 )
		{
			close (file);
			//    !
			return (1);
		}
		//    !
		sys = whatsys(name, dir, 0);
		if ( sys != 2 )
			break;
	}
	while ( 1 );
	close (file);
	if ( sys != 0 )
		return (1);
	if ( sizefile(name, dir, 0) != 0 )
		return (1);	//   !  !
	sizetmp = NSIZE + TSIZE;
	if ( Size[PASSW] < sizetmp )
	{
		limitfile(name);
		return (2);	//     !
	}
	NSIZE = sizetmp;
	descfile(name, dir, 0);
	return (0);
}*/

/*
 *  -   ,    .
 * : name -  
 * : dir -     , errorlevel = 0 ( 1)
 * 	  name -   . 2 -  , 3 - . .
*/

//     
foundalias(char* name, char* dir)
{
	int file;
	int file0;
	int n = 0, m = 0, i;
	unsigned int sizetmp;
	char buffer[512];
	char tmp[512];
/*	if ( checkname(name) )	//    
		return (3);*/
	//    
	if ((file = open(ALIASES, O_RDONLY, 0)) == -1 )
		//    !
		return (1);
	do
	{
		if ( getline(file, buffer ,sizeof(buffer)) == 0 )
		{
			close (file);
			return (1);
		}
	}
	while ( strncmp(buffer, name, strlen(name)) != 0 );
	//      
	while ( buffer[n++] != '\x2F' );	//   '/'
	tmp[m] = '\x2F';			//   - '/'
	while ( buffer[n] != 0 )
		tmp[++m] = buffer[n++];
	tmp[++m] = 0;		//   - 0
	strcpy (dir, tmp);
	close (file);
	//      
/*	i = strlen(dir) - 1; n = 0;
	while ( dir[i--] != '\x2F' );
	i++; i++;
	while ( dir[i] != 0 )
		name[n++] = dir[i++];
	name[n] = 0;
	if ( sizefile(name, dir, 1) != 0 )
		return (2);	//   !  !
	sizetmp = NSIZE + TSIZE;
	if ( Size[PASSW] < sizetmp )
	{
		limitfile(name);
		return (2);	//     !
	}
	NSIZE = sizetmp;*/
	return (0);
}

//     (  )
// : 0 -  ; 1 -   .
checkname(char* name)
{
/*	int n = 3, m = 0;
	char check[3][5] = {".", "..", "fuck"};
	char buf[255];
	while ( m != n )
	{
		if ( !strncmp( name, check[m], strlen( check[m++] ) ) )
			return (1);
	}*/
	//          
	//  ':','\','/'
	if ( strpbrk( name, "/" ) )
		return (1);
	return (0);
}

/*
 *   .desc  .
 * : dir -   ;
 * : errorlevel
 * 	0 -    ( 'p')
 * 	1 -  /  ( 'l')
 * 	2 -    ( 'a')
 * 	3 -      ( ,    ,
 * 	    'p','l','a')
*/
whatdir(char* dir)
{
	int fd, f;
	char d[1];
	char file[255];
	sprintf(file, "%s/.desc/.desc", dir);
	if ((fd = open(file, O_RDONLY, 0)) == -1 )
		//     .desc -  !
		return (3);
	if ( read(fd, d, 1) == 0 )
	{
		//  .desc   -  !
		close (fd);
		return (3);
	} 
	close (fd);
	if ( d[0] == 'p' )
		return (0);
	if ( d[0] == 'l' )
		return (1);
	if ( d[0] == 'a' )
		return (2);
	else
		return (3);
}

/*
 *         ?
 * : name - , dir - .
 * : errorlevel
 * 	0 -  
 * 	1 -   
 * 	2 -           !
*/
whatsys(/*char* name,*/ char* dir /*, int alias*/)
{
	int wdir;
	/*char fileindir[255];
	if ( alias != 0 )
		sprintf(fileindir, "%s", dir);
	else
		sprintf(fileindir, "%s/%s", dir, name);
	if ((access(fileindir, F_OK | R_OK)) == -1) //     'r'
		return (2);*/
	wdir = whatdir(dir);
	if ( PASSW <= wdir && wdir != 3 )
		return (0);
	else
		return (1);
}

// ,   
sizefile(char* name, char* dir, int flag)
{
	// flag: 0 - , 1 - 
	char buf[80];
	char buffer[255];
	struct stat	statv;
	unsigned int size;
	if ( flag != 0 )
		strcpy(buffer, dir);
	else
		sprintf(buffer, "%s/%s", dir, name);
	if ( stat(buffer, &statv) )
	{
		if ( errno != ENOENT )
		{
			sprintf(buf, "Freq file \"%s\" - unknown error!", buffer);
			mylog(buf);
		};
		return (1);
	}
	size = statv.st_size;
	TSIZE = size;
	return (0);
}

//  rep -
// : dir -   , name -  
descfile(char* name, char* dir, int alias)
{
	int file, size;
	char filedesc[255];
	char buffer[SIZE];
	char newname[80];
	char newbuffer[SIZE+1];
	char newdir[255];
	char buf[80];
	sprintf(filedesc, "%s/.desc/%s.desc", dir, name);
	if ((file = open(filedesc, O_RDONLY, 0)) == -1 )  //  .desc
		//   !
		strcpy(buffer, DESC);
	//  name  REP - ( )
	sprintf(newname, "> %s, size: %d\n", name, TSIZE);
	write(frep, newname, strlen(newname));
	if ( file != -1 )
	{
		size = read(file, buffer, SIZE);
		buffer[size-1] = '\n';
		buffer[size] = 0;
	}
	//  buffer  REP - ( )
	sprintf(newbuffer, "%s\n", buffer);
	write(frep, newbuffer, strlen(newbuffer));
	//        OUT -
	if ( alias != 0 )
		sprintf(newdir, "%s %s\n", dir, name);
	else
		sprintf(newdir, "%s/%s %s\n", dir, name, name);
	write(fout, newdir, strlen(newdir));
	sprintf(buf, "Freq file \"%s\", size: %d - ok!", name, TSIZE);
	mylog(buf);	//       
	NFILE++;	//  -  
	//    
	if ( file != -1 )
		close (file);
}

//     freq -
repwithoutfile(char* name)
{
	char buf[80];
	char buffer[80];
	sprintf(buffer, "> %s\n", name);
	write(frep, buffer, strlen(buffer));
	write(frep, FMISSING, strlen(FMISSING));
	sprintf(buf, "Freq file \"%s\" - file not found!", name);
	mylog(buf);
}

//       
manyfile(char* name)
{
	char buf[80];
	char buffer[80];
	sprintf(buffer, "> %s\n", name);
	write(frep, buffer, strlen(buffer));
	write(frep, MANYFILE, strlen(MANYFILE));
	sprintf(buf, "Freq file \"%s\" - out of file limit!", name);
	mylog(buf);
}

//       
limitfile(char* name)
{
	char buf[80];
	char buffer[80];
	sprintf(buffer, "> %s\n", name);
	write(frep, buffer, strlen(buffer));
	write(frep, SIZEFILE, strlen(SIZEFILE));
	sprintf(buf, "Freq file \"%s\" - size limit is exhausted!", name);
	mylog(buf);
}

//      security
security(char* name)
{
	char buf[255];
	char buffer[80];
	sprintf(buffer, "> %s\n", name);
	write(frep, buffer, strlen(buffer));
	write(frep, SECURITY, strlen(SECURITY));
	sprintf( buf, "Attention! Freq file \"%s\" - security violation error!", name );
	mylog(buf);
	system(SENDADMIN);	//   !
}

//   REP -
endrep()
{
	char buf[80];
	char buffer[80];
	char newbuffer[80];
	sprintf(buffer, "\n\tYour limits: %d files, %d bytes\n\n", MaxFile[PASSW], Size[PASSW]);
	write(frep, buffer, strlen(buffer));
	sprintf(newbuffer, "\tFREQ time access: %s\n\n", ENDREP);
	write(frep, newbuffer, strlen(newbuffer));
	sprintf(buf, "Statistics: %d file(s) requested, total size: %d bytes", NFILE, NSIZE);
	mylog(buf);
	sprintf(newbuffer,"--- External freq processor (v%d.%d) (C) Maxim Timofeyev, 2:5030/763\n\n", VER, SUBVER);
	write(frep, newbuffer, strlen(newbuffer));
	myexit ();
}

//  - -       log-
loginit()
{
	int mon, day, hour, min, sec;
	char month[12][4] = {"Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec"};
	time_t timv = time (0);
	struct tm *local_tm = localtime ( &timv );
	mon = local_tm->tm_mon;
	day = local_tm->tm_mday;
	hour = local_tm->tm_hour;
	min = local_tm->tm_min;
	sec = local_tm->tm_sec;
	sprintf(LOGINIT, "%s %02d %02d:%02d:%02d ifextfreq:", month[mon], day, hour, min, sec);
	OpenLog();	//  log -  
}

//   log -
mylog(char *buf)
{
	char buffer[255];
	sprintf(buffer, "%s %s\n", LOGINIT, buf);
	write(logfile, buffer, strlen(buffer));
}

//   log - 
myexit()
{
	write(logfile, "--\n", 3);
	close (logfile);
}
